<!doctype html>
<!--
    Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 3.3 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="./">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v6.0-M1</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v6.0-M1">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 3.3: Supervisory controller synthesis</h1>
                    <p>
                        Now that you know about the controllability, non-blockingness and maximal-permissiveness guarantees of supervisory controller synthesis, it is time to look at the synthesis algorithm itself.
                        The synthesis algorithm constructs a proper supervisor, in a systematic way.
                        That is, given a plant model model, the algorithm computes a controllable, non-blocking and maximally-permissive supervisor.
                        First, we look at a simple example.
                        And then we discuss the general steps that are involved in the synthesis algorithm.
                    </p>
                    <p>
                        Do keep in mind that in this module, user-provided requirements and the associated safety guarantee are not yet considered.
                        Since they are covered later in Module 4, the algorithm as we discuss it here is not yet the full algorithm.
                    </p>

                    <h2 id="example">Example</h2>
                    <p>
                        Consider the automata shown below.
                        They are adapted versions of the automata from the <a href="../module2/synchronizing-automata.html#quiz">quiz of the module on synchronizing automata</a>.
                        The initial and marked locations have changed, and event <code>f</code> has become an uncontrollable event.
                        Other than that, they are the same.
                    </p>
                    <img src="images/synthesis-example1.png">
                    <img src="images/synthesis-example2.png">
                    <p>
                        The synthesis algorithm is easier to explain when applied to a single automaton, rather than to multiple ones.
                        Therefore, we first compute the state space automaton of the two automata above, which is shown below.
                        The actual synthesis algorithm in CIF does not first construct the full state space before computing the supervisor.
                        Instead, it computes the supervisor directly from the multiple automata, in a more efficient manner.
                        Conceptually though, the task of synthesizing a supervisor is the same.
                    </p>
                    <img src="images/synthesis-example3.png">
                    <p>
                        Through synthesis, a supervisor is derived from the plant model.
                        You may have already noticed that state <code>(3, 1)</code> is blocking state, since it is not a marked state, and no marked state can be reached from it.
                        The supervisor should prevent the system from getting into this state, to avoid blocking behavior.
                        The state is a bad state and is thus removed.
                        And as a consequence of removing it, all its outgoing transitions are also no longer possible.
                        The self-loop transition on state <code>(3, 1)</code> can thus never be taken anymore:
                    </p>
                    <img src="images/synthesis-example4.png">
                    <p>
                        To make sure the removed state can never be reached, the supervisor has to disable all transitions leading to that state.
                        In this case, that concerns three transitions: the transition from state <code>(1, 1)</code> for event <code>e</code>, the transition from state <code>(2, 1)</code> for event <code>f</code>, and the transition from state <code>(3, 2)</code> for event <code>a</code>.
                        Out of these three transitions, two transitions are for controllable events.
                        These two transitions can be directly disabled by the supervisor.
                    </p>
                    <img src="images/synthesis-example5.png">
                    <p>
                        The third transitions is for an uncontrollable event.
                        A supervisor may never disable uncontrollable events, as that would violate the controllability guarantee.
                        Therefore, the supervisor must thus ensure that state <code>(2, 1)</code> is never reached, since if it would be reached, then through an uncontrollable event that the supervisor can't prevent, the system could end up in a blocking state, namely removed state <code>(3, 1)</code>.
                        State <code>(2, 1)</code> is thus a bad state, and is removed.
                        Its outgoing transitions are then also no longer possible:
                    </p>
                    <img src="images/synthesis-example6.png">
                    <p>
                        Then there are the two transitions to removed state <code>(2, 1)</code> to consider.
                        The transitions from state <code>(1, 1)</code> for event <code>c</code> and the transitions from state <code>(2, 2)</code> for event <code>a</code>, both involve controllable events.
                        The supervisor can thus disable them directly:
                    </p>
                    <img src="images/synthesis-example7.png">
                    <p>
                        We have now completed one iteration of removing blocking states, while ensuring controllability is preserved.
                        However, state <code>(1, 1)</code> has now become a blocking state.
                        It is thus a bad state, and is removed.
                        It has no incoming transitions for uncontrollable events.
                        It has one incoming transition, the transition for from state <code>(1, 2)</code> for controllable event <code>a</code>.
                        Event <code>a</code> is thus disabled in state <code>(1, 2)</code>:
                    </p>
                    <img src="images/synthesis-example8.png">
                    <p>
                        We have now completed two iterations of removing blocking states, while ensuring controllability is preserved.
                        This automaton is a controllable, non-blocking and maximally-permissive supervisor for this example.
                    </p>
                    <p>
                        Note that its alphabet is the same as the original automaton, and thus includes events <code>a</code>, <code>b</code>, <code>c</code>, <code>d</code>, <code>e</code> and <code>f</code>.
                        That is, it has an alphabet containing events that are not on any of the edges of the automaton, namely events <code>a</code> and <code>c</code>.
                        In a CIF model of this automaton, this alphabet would thus need to be explicitly declared, to ensure the supervisor properly disables these events.
                        Without the explicit alphabet, a plant automaton with an edge for event <code>a</code> could still take that edge, since the supervisor would not synchronize on the event and would thus not disable it.
                        Hence, such a supervisor automaton always has the same alphabet as the plant.
                    </p>

                    <h2>The synthesis algorithm</h2>
                    <p>
                        For the example above, we started with the state space of the plant.
                        We then systematically removed non-blocking states and ensured controllability is preserved, while only removing states and transitions where it was necessary.
                    </p>
                    <p>
                        In general, the synthesis algorithm takes the uncontrolled plant as the initial supervisor.
                        It then performs the following steps to turn it into a proper supervisor, repeating the steps if any of them led to removing any states or disabling any transitions:
                    </p>
                    <ol>
                        <li>
                            Determine all blocking states.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Determine all non-controllable states, the states from which an uncontrollable-event transition is possible to a bad state.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Optionally, determine all unreachable states.
                            Mark them as bad states and remove them.
                        </li>
                        <li>
                            Disable all transitions for controllable events in states where they lead to a bad state.
                        </li>
                    </ol>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'single-choice',
                                question: "What would be a controllable, non-blocking and maximally-permissive supervisor for the example above, if plant state <code>(3, 1)</code> would be a marked state instead of state <code>(3, 2)</code>?",
                                answers: [
                                    "The supervisor that was the result of the first iteration as discussed above.",
                                    "The supervisor that was synthesized for the example still suffices.",
                                    "Since the only blocking location is now marked, the plant itself can in this case serve as a controllable, non-blocking and maximally-permissive supervisor."
                                ],
                                correctAnswer: '3'
                            },
                            {
                                type: 'single-choice',
                                question: "What would be a controllable, non-blocking and maximally-permissive supervisor for the example above, if plant state <code>(1, 2)</code> would be the initial state instead of state <code>(2, 2)</code>?",
                                answers: [
                                    "The supervisor that was the result of the first iteration as discussed above.",
                                    "The supervisor that was synthesized for the example still suffices.",
                                    "The supervisor that was synthesized for the example is adapted by removing unreachable state <code>(2, 2)</code>, such that only states <code>(1, 2)</code> and <code>(3, 2)</code> remain.",
                                    "Since the only blocking location is now marked, the plant itself can in this case serve as a controllable, non-blocking and maximally-permissive supervisor."
                                ],
                                correctAnswer: '3'
                            },
                            {
                                type: 'single-choice',
                                question: "What are the four steps of the supervisory controller synthesis algorithm?",
                                answers: [
                                    "1: Remove all blocking states. 2: Remove all non-controllable states. 3: Remove all unreachable states. 4: Remove all controllable-event transitions to removed states.",
                                    "1: Remove all non-controllable states. 2: Remove all blocking states. 3: Remove all unreachable states. 4: Remove all controllable-event transitions to removed states.",
                                    "1: Remove all non-controllable states. 2: Remove all blocking states. 3: Remove all controllable-event transitions to bad states. 4: Remove all unreachable states.",
                                    "1: Remove all blocking states. 2: Remove all controllable-event transitions to bad states. 3: Remove all unreachable states. 4: Remove all uncontrollable-event transitions to bad states.",
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'multiple-choice',
                                question: `
                                    Consider the following two alternative supervisors for the example above.
                                    Are these also proper controllable, non-blocking and maximally-permissive supervisors, like the one we synthesized?
                                    Hint: Consider the uncontrolled system state space versus the controlled system state space, for the plant combined with each of these alternative supervisors.
                                    <img src="images/synthesis-example-quiz.png">
                                `,
                                answers: [
                                    "The left automaton is a proper alternative supervisor.",
                                    "The right automaton is a proper alternative supervisor."
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    What happens if synthesis is applied to the following plant model?
                                    <img src="images/synthesis-all-bad-except-initial.png">
                                `,
                                answers: [
                                    "The plant is the same as the supervisor.",
                                    "Synthesis removes all states, except for the initial state.",
                                    "All states are bad, and thus no supervisor can be computed.",
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    What happens if synthesis is applied to the following plant model?
                                    <img src="images/synthesis-all-bad-empty-supervisor.png">
                                `,
                                answers: [
                                    "The plant is the same as the supervisor.",
                                    "Synthesis removes all states, except for the initial state.",
                                    "All states are bad, and thus no supervisor can be computed.",
                                ],
                                correctAnswer: '3'
                            }
                        ]
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="synthesis-guarantees.html">Go back to Module 3.2</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="modeling-larger-systems.html">Proceed to Module 3.4</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2024 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
